local _G = _G
local white = "|cffffffff"

local function mouseEnter(self)

	local parent = self:GetParent()
	
	if self.id ~= parent.selected then
	
		self:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background"})
		self:SetBackdropColor(0, 0, 0, 0.4)
		
	end
	
end

local function mouseClick(self)

	self:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background"})
	self:SetBackdropColor(0, 0, 0, 0.7)
	
end

local function mouseLeave(self)

	local parent = self:GetParent()
	
	if self.id ~= parent.selected then
	
		self:SetBackdrop(nil)
		
	end
	
end

local function sortQuests(a, b)

	local weighta, weightb = "z", "z"
	local ca, cb, c, sa, sb
	
	if (a[3] or 0) == 1 then weighta = "a" end
	if (a[3] or 0) == 0 and (a[4] or 0) == 0 and (a[5] or 0) == 0 then weighta = "b" end
	if (a[5] or 0) == 1 then weighta = "c" end
	if (b[3] or 0) == 1 then weightb = "a" end
	if (b[3] or 0) == 0 and (b[4] or 0) == 0 and (b[5] or 0) == 0 then weightb = "b" end
	if (b[5] or 0) == 1 then weightb = "c" end
	
	sa = string.lower(string.sub(a[1], 11))
	sb = string.lower(string.sub(b[1], 11))
	ca = weighta .. sa
	cb = weightb .. sb
	
	return ca < cb

end

function Loremaster:clickResponder(self)

	local parent = self:GetParent()
	local row, zones, z, c, k, v, detail, q
	local data, qdata, dat = {}, {}, {}
	local item, series, first, other = "|cffffd200", "|cff668b8b", "|cff70db93", "|cffffffff"
	local ach, det
	
	if parent.selected then
	
		Loremaster:resetLines(parent)
		
	end
	
	mouseClick(self)
	parent.selected = self.id

	if parent.name == "LoremasterContinentFrame" then
	
		Loremaster.currentcontinent = self.id
		LoremasterContinentFrame.currentline = self	
		
		if Loremaster.db.profile.hideach then

			for ach, det in pairs(LoremasterDB.Achievements[self.id] or {}) do
			
				if det[3] == false then
				
					table.insert(dat, LoremasterDB.Achievements[self.id][ach])
					
				end
				
			end
			
		else
		
			dat = (LoremasterDB.Achievements[self.id] or {})
			
		end

		LoremasterZoneFrame.data = dat
		table.sort(LoremasterZoneFrame.data, function(a, b) return string.lower(string.sub(a[1], 11)) < string.lower(string.sub(b[1], 11)) end)
		Loremaster:updateScroll(LoremasterZoneFramescroll)
		LoremasterQuestFrame.data = {}
		LoremasterQuestFrame.qdata = {}
		Loremaster:updateQuestCount(-1)
		Loremaster:updateZoneCount(#dat)
		Loremaster:updateScroll(LoremasterQuestFramescroll)
		LoremasterZoneFrame.selected = nil
		LoremasterZoneFrame.currentline = nil
		LoremasterQuestFrame.selected = nil
		LoremasterInfoFrame.qid = nil
		LoremasterInfoFrame.x = nil
		LoremasterInfoFrame.y = nil
		LoremasterInfoFrame.z = nil
		LoremasterInfoFrame.target = nil
		LoremasterInfoBox:SetText("")
		
	elseif parent.name == "LoremasterZoneFrame" then
	
		zones = Loremaster.AchZones[self.id]
		Loremaster.currentzone = self.id
		LoremasterZoneFrame.currentline = self
		
		if #zones > 0 and LoremasterDB.available then
		
			for _, z in ipairs(zones) do

				for k, v in pairs(LoremasterDB.available[tostring(Loremaster.currentcontinent)][z]) do
				
					if v[10] == 1 then
					
						c = item
						
					elseif v[9] == 1 then
					
						c = first
						
					elseif v[8] == 1 then
					
						c = series
						
					else
					
						c = other
						
					end
					
					table.insert(data, {c .. v[7], k, v[9], v[8], v[10]})
					table.insert(qdata, {
					qid = k, z = v[1], l = v[2], x = v[4], y = v[5], npc = v[6], 
					s = v[8], f = v[9], i = v[10], dup = v[11], drop = v[12]})
					
				end
				
			end
			
		else
		
			return
		
		end
		
		LoremasterQuestFrame.data = data
		LoremasterQuestFrame.qdata = qdata
		LoremasterQuestFrame.selected = nil
		LoremasterInfoFrame.qid = nil
		LoremasterInfoFrame.x = nil
		LoremasterInfoFrame.y = nil
		LoremasterInfoFrame.z = nil
		LoremasterInfoFrame.target = nil
		Loremaster:updateQuestCount(#data)
		LoremasterInfoBox:SetText("")
		table.sort(LoremasterQuestFrame.data, sortQuests)
		Loremaster:updateScroll(LoremasterQuestFramescroll)
			
	elseif parent.name == "LoremasterQuestFrame" then
	
		for k, v in pairs(LoremasterQuestFrame.qdata) do
		
			if v.qid == self.id then
			
				detail = v
				break
				
			end
			
		end
		
		Loremaster:setNotes(detail)
		
		if Loremaster.LH then
		
			LightHeadedFrame:Hide()
			
		end
		
	end
		
end

function Loremaster:updateScroll(frame)

	local valueStep = 16
	local line, linePlusOffset, fLine
	local numItems
	local parent = frame:GetParent()
	local numToDisplay = parent.displaylines
	local text, id
	
	if parent.data then
	
		numItems = table.getn(parent.data)

		FauxScrollFrame_Update(frame, numItems, numToDisplay, valueStep)

		if numItems == 0 then

			for line = 1, numToDisplay do

				fLine = _G[parent.name .. line]
				fLine:Hide()

			end
	
		else

			for line = 1, numToDisplay do

				linePlusOffset = line + FauxScrollFrame_GetOffset(frame)
				fLine = _G[parent.name .. line]

				if linePlusOffset <= numItems then

					pretmp = parent.name .. line .. "_"
					text = parent.data[linePlusOffset][1]
					id = parent.data[linePlusOffset][2]
					_G[pretmp .. "f1"]:SetText(white .. text)
					fLine.id = id
					fLine:SetScript("OnMouseDown", function(self) Loremaster:clickResponder(self) end)
					fLine:SetScript("OnEnter", mouseEnter)
					fLine:SetScript("OnLeave", mouseLeave)
					
					if id == parent.selected then
					
						mouseClick(fLine)
						
					else
					
						fLine:SetBackdrop(nil)
						
					end
					
					fLine:Show()

				else

					fLine:Hide()

				end

			end

		end
	
	end
	
end

function Loremaster:createLine(parent, linename)

	local frame= CreateFrame("Frame", linename, parent)
	local f1 = frame:CreateFontString("$parent_f1", "ARTWORK", "GameFontNormal")

	frame:SetHeight(16)
	frame:SetWidth(parent:GetWidth() - 38)

	f1:SetPoint("LEFT", frame, "LEFT")
	f1:Show()

	return frame

end

function Loremaster:placeLines(frame, lines)

	local c, ypos, pre, tmp

	pre = frame.name
	ypos = -14
	
	for c = 1, lines do

		tmp = Loremaster:createLine(frame, pre .. c)
		tmp:SetPoint("TOPLEFT", frame, "TOPLEFT", 10, ypos)
		tmp:Hide()
		ypos = ypos - 20

	end

end

function Loremaster:createScrollFrame(parent, name)

	local frame = CreateFrame("ScrollFrame", name, parent, "FauxScrollFrameTemplate")
	local itemHeight = 16

	frame:SetScript("OnVerticalScroll", function(self, offset) FauxScrollFrame_OnVerticalScroll(self, offset, itemHeight, function() Loremaster:updateScroll(frame) end) end)
	frame:EnableMouseWheel(true)
	frame:SetScript("OnMouseWheel", ScrollFrameTemplate_OnMouseWheel)
	frame.name = name
	
	return frame

end

function Loremaster:createDisplayFrame(parent, framename, lines, height, width, data)

	local frame = CreateFrame("Frame", framename, parent)
	local sframe = Loremaster:createScrollFrame(frame, framename .. "scroll")

	frame:SetMovable(false)
	frame:EnableMouse(true)
	frame:EnableKeyboard(true)
	frame:SetHeight(height)
	frame:SetWidth(width)
	frame:SetBackdrop({bgFile = Loremaster[framename].bgfile, edgeFile = Loremaster[framename].edgefile, edgeSize = 16, insets = {left = 4, right = 4, top = 4, bottom = 4}})
	frame.data = data
	frame.name = framename
	frame.displaylines = lines
	
	sframe:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, -10)
	sframe:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -32, 10)

	Loremaster:placeLines(frame, lines)

	local function frameOnShow(self)

		Loremaster:updateScroll(sframe)

	end

	frame:SetScript("OnShow", function(self) frameOnShow(self) end)

	return frame

end